package server

type Servlet interface {
	ServletCtx(serverCtx ServerCtx) ServletCtx

	Init(serverCtx ServerCtx) error
	OnStart(serverCtx ServerCtx) error
	OnStop(serverCtx ServerCtx)
	Destroy(serverCtx ServerCtx)
}
