package socket

import (
	"git.loafle.net/overflow/server-go"
)

type Servlet interface {
	server.Servlet

	OnConnect(servletCtx server.ServletCtx, conn Conn)
	Handle(servletCtx server.ServletCtx, stopChan <-chan struct{}, doneChan chan<- struct{}, readChan <-chan SocketMessage, writeChan chan<- SocketMessage)
	OnDisconnect(servletCtx server.ServletCtx)
}
